//---------------------------------------------------------------------------

#ifndef StatsWins4H
#define StatsWins4H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <Tabs.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <IniFiles.hpp>
#include <Dialogs.hpp>
#include "RemailerDocs.h"
//---------------------------------------------------------------------------

class TQSStatsWin4 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu;
        TMenuItem *FileMenu;
        TMenuItem *FileExit;
        TMenuItem *UpdateSaveItem;
        TMenuItem *ToolsMenu;
        TMenuItem *Options1;
        TMenuItem *HelpMenu;
        TMenuItem *About1;
        TMenuItem *ViewMenu;
        TMenuItem *UpdateMenu;
        TMenuItem *FileUpdateItem;
        TMenuItem *FileUpdateSelectItem;
        TPopupMenu *PopupMenu1;
        TMenuItem *Update3;
        TMenuItem *Updateselect1;
        TTimer *Timer1;
        TMenuItem *RearrangeURLsources;
        TMenuItem *ToolsBarRemailerItem;
        TMenuItem *ToolsURLManagerItem;
        TMenuItem *N3;
        TCoolBar *CoolBar;
        TPanel *Panel3;
        TLabel *Label1;
        TToolBar *ToolBar;
        TToolButton *RunBtn;
        TToolButton *CancelBtn;
        TToolButton *ToolbarDivider1;
        TToolButton *SaveBtn;
        TToolButton *ToolButton1;
        TMenuItem *UpdateCloseAllItem;
        TOpenDialog *OpenDialog;
        TTimer *Timer2;
        TTimer *Timer3;
        TMenuItem *ToolsProxyItem;
        TToolButton *OkBtn;
        TToolButton *TB3;
        TToolButton *KeyringBtn;
        TToolButton *KeyringSep;
        TMenuItem *KeyringsMenu;
        TMenuItem *KeyringsCypherpunkItem;
        TMenuItem *KeyringsNymserverItem;
        TMenuItem *KeyringsMixmasterItem;
        TPopupMenu *PopupMenu2;
        TMenuItem *MixmasterKeyring1;
        TMenuItem *Cypherpunk2;
        TMenuItem *Nymserver1;
        TPopupMenu *PopupMenu3;
        TMenuItem *PopSaveAndExitItem;
        TMenuItem *PopExitItem;
        TStatusBar *StatusBar;
        TTimer *Timer4;
        TMenuItem *ViewAllPagesItem;
        TMenuItem *N2;
        TMenuItem *ViewMlistTxtItem;
        TMenuItem *ViewPubringMixItem;
        TMenuItem *ViewRlistTxtItem;
        TMenuItem *ViewPubringAscItem;
        TMenuItem *N4;
        TMenuItem *ViewAdvisoryTxtItem;
        TMenuItem *ViewNymserverAscItem;
        TMenuItem *UpdateMlistTxtItem;
        TMenuItem *UpdatePubringMixItem;
        TMenuItem *UpdateRlistTxtItem;
        TMenuItem *UpdatePubringAscItem;
        TMenuItem *UpdateAdvisoryTxtItem;
        TMenuItem *UpdateNymserverAscItem;
        TTimer *Timer5;
        TMenuItem *N6;
       TMenuItem *UpdateURLsTxtItem;
        TMenuItem *N8;
        TMenuItem *UpdatePrintItem;
        TMenuItem *ViewURLsTxtItem;
        TToolButton *PrintBtn;
        TMenuItem *N5;
        TMenuItem *SourceMenu;
        TMenuItem *ProxyMenu;
        TMenuItem *N7;
        TMenuItem *N10;
        TMenuItem *ViewToolBarItem;
        TMenuItem *ViewStatusBarItem;
        TMenuItem *N1;
        TComboBox *SourceBox;
        TComboBox *ProxyBox;
        TProgressBar *ProgressBar;
        TStaticText *StaticText4;
        TStaticText *StaticText3;
        TTabControl *TabSet;
        TRichEdit *BlankView;
        TMenuItem *HelpTopicsItem;
        TMenuItem *HelpHistoryItem;
        TMenuItem *N9;
        TMenuItem *wwwnoreplyorg1;
        TMenuItem *N11;
        TMenuItem *Home1;
        TMenuItem *Latency1;
        TMenuItem *Remsaint1;
        TMenuItem *AllPingers1;
        TMenuItem *type2list1;
        TMenuItem *ViewMail2newsTxtItem;
        TMenuItem *UpdateMail2newsTxtItem;
        void __fastcall FileExitClick(TObject *Sender);
        void __fastcall TabSetChange(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall FileUpdateItemClick(TObject *Sender);
        void __fastcall RunBtnClick(TObject *Sender);
        void __fastcall CancelBtnClick(TObject *Sender);
        void __fastcall FileUpdateSelectItemClick(TObject *Sender);
        void __fastcall Options1Click(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall ViewToolbarItemClick(TObject *Sender);
        void __fastcall ViewStatusBarItemClick(TObject *Sender);
        void __fastcall ToolsURLManagerItemClick(TObject *Sender);
        void __fastcall RearrangeURLsourcesClick(TObject *Sender);
        void __fastcall ToolsBarRemailerItemClick(TObject *Sender);
        void __fastcall UpdateCloseAllItemClick(TObject *Sender);
        void __fastcall ViewOtherFileItemClick(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall QuickStart1Click(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall OkBtnClick(TObject *Sender);
        void __fastcall Timer3Timer(TObject *Sender);
        void __fastcall ToolsProxyItemClick(TObject *Sender);
        void __fastcall KeyringsMixmasterItemClick(TObject *Sender);
        void __fastcall KeyringsCypherpunkItemClick(TObject *Sender);
        void __fastcall KeyringsNymserverItemClick(TObject *Sender);
        void __fastcall KeyringsMenuClick(TObject *Sender);
        void __fastcall KeyringBtnClick(TObject *Sender);
        void __fastcall ViewMenuClick(TObject *Sender);
        void __fastcall PopupMenu3Popup(TObject *Sender);
        void __fastcall UpdateMenuClick(TObject *Sender);
        void __fastcall ToolsMenuClick(TObject *Sender);
        void __fastcall Timer4Timer(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall Hist1Click(TObject *Sender);
        void __fastcall SourceBoxChange(TObject *Sender);
        void __fastcall ProxyBoxChange(TObject *Sender);
        void __fastcall ViewMenuItemClick(TObject *Sender);
        void __fastcall Timer5Timer(TObject *Sender);
        void __fastcall UpdatePrintItemClick(TObject *Sender);
        void __fastcall FileMenuClick(TObject *Sender);
        void __fastcall UpdateSaveItemClick(TObject *Sender);
        void __fastcall HelpTopicsItemClick(TObject *Sender);
        void __fastcall HelpHistoryItemClick(TObject *Sender);
        void __fastcall Home1Click(TObject *Sender);
        void __fastcall Latency1Click(TObject *Sender);
        void __fastcall Remsaint1Click(TObject *Sender);
        void __fastcall AllPingers1Click(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
        TColor WindowColor;
        int ChildX, ChildY, result;
        TStringList *mlistorg, *rlistorg, *Proxy, *Proxies, *newbars, *AutoRunFiles;
        bool Cancel, AutoLoad, AutoRun, Hidden, BarsModified, ExpertMode, BarNewRemailers;
        AnsiString MixmasterDir, PageSource, Label1Cap, WinsFontStr, DlgsFontStr, EditFontStr;
        AnsiString LastSource; // for catching source change
        __fastcall TQSStatsWin4(TComponent* Owner);
        __fastcall virtual ~TQSStatsWin4();

        void __fastcall GenType2List(TStrings *pubringmix, AnsiString ModifiedDate);
        void __fastcall BundleCypherpunkNymservers();
        void __fastcall GetProxies(TIniFile *ini);
        void __fastcall AppMessage(tagMSG &Msg, bool &Handled);
        void __fastcall MoveSource(const AnsiString &Source, int Position);
        void __fastcall AddUpdateMenuItem(const AnsiString &Page, bool Enabled);
        void __fastcall AddViewFileMenuItem(const AnsiString &Page);
        void __fastcall LoadSourceConfig(TIniFile *ini, const AnsiString &Source);
        bool __fastcall GetLocalDocument(const AnsiString &DocName);
        int  __fastcall GetLocalDocumentTab(const AnsiString &DocName);
        void __fastcall OpenLocalPage(const AnsiString &docname);
        void __fastcall LoadPAGEs(const AnsiString &Source, TStrings *Pages);
        void __fastcall LoadPAGENames(const AnsiString &Source, TStrings *Pages);
        void __fastcall LoadURLs(const AnsiString &Source, TStrings *URLs);
        AnsiString __fastcall GetURL(const AnsiString &Source, const AnsiString &Page);
        void __fastcall DoRequest(const AnsiString &URL);
        void __fastcall PutLastSource(const AnsiString &Source);
        AnsiString __fastcall GetLastSource();
        AnsiString __fastcall GetSource(int index = 0);
        AnsiString __fastcall GetPlainText();
        void __fastcall OpenLocalFiles();
        bool __fastcall FailErrorCheck();
        int  __fastcall ValidPages();
        bool __fastcall IsLocalAndModified(TRemailerDoc *Doc);
        bool __fastcall Working();
        bool __fastcall CheckSave();
        void __fastcall Save();
        void __fastcall AddToLast(TStrings *feedback, const AnsiString &text);
        void __fastcall LoadIni();
        void __fastcall SaveIni();
        void __fastcall ReformatMListTxt(TStrings *page);

        bool __fastcall CanCascade(const AnsiString &PageName);
        int  __fastcall GetRemailerPage(const AnsiString &Source, const AnsiString &URL,
           const AnsiString &PageName, TStrings *Page, bool CheckDate, int timeoutsecs);
        int  __fastcall GetRemailerPages(const AnsiString &Source, TStrings *Pages,
           TRemailerDoc *doc, TStrings *Report, int timeoutsecs);
        int  __fastcall GetQuickSilverPage(const AnsiString &Source, const AnsiString &URL,
           const AnsiString &PageName, TStrings *Page, int timeoutsecs);
        int  __fastcall GetQuickSilverPages(TStrings *Pages, TRemailerDoc *doc,
           TStrings *Report, bool &NewAdvisory, int timeoutsecs);
        void __fastcall UpdatePagesSource(const AnsiString &Source, TStrings *rempages);
        void __fastcall UpdatePages(const AnsiString &psource, TStrings *rempages,
           const AnsiString &qsource, TStrings *qicpages);
        void __fastcall FileUpdateAutoRunFiles();

        TRemailerDoc* __fastcall NewLocalRemailerDoc(const AnsiString &Source,
           const AnsiString &FileName, TStrings *Lines);
        TRemailerDoc* __fastcall NewRemailerDoc(const AnsiString &Source,
           AnsiString Name, TStrings *Lines, bool Status);

        void __fastcall SourceMenuItemClick(TObject *Sender);
        void __fastcall ProxyMenuItemClick(TObject *Sender);

        TRichEdit* __fastcall TabEditor(int index);
        void __fastcall SetEditorHideSelection(bool hide);
        TRemailerDoc* __fastcall TabRemailerDoc(int index);
        int  __fastcall GetPagesEnabled(TStrings *Pages);
        void __fastcall SetPageEnabled(const AnsiString &Page, bool Enabled);
        bool __fastcall GetPageEnabled(const AnsiString &Page);
        void __fastcall GetPage(const AnsiString &Page, TStrings *Text);
        int  __fastcall PageNo(const AnsiString &Page);
        void __fastcall ClearTabs();
        AnsiString __fastcall PathName(AnsiString page);
        bool __fastcall BringPageToFront(const AnsiString &page);
        void __fastcall DisplayStatus(const AnsiString &Msg);
        void __fastcall ShowToolBar(bool Show);
        //bool __fastcall SecureMode();

        void __fastcall RemoveBarredRemailersFromStatsFiles();
        void __fastcall RemoveBarredRemailers(const AnsiString &PageName, TStrings *page);
        bool __fastcall MarkMiddlemanRemailers(const AnsiString &Page, TStrings *ring);
        bool __fastcall MarkMixmasterMiddlemen(TStrings *last, TStrings *mring);
        void __fastcall SaveNewBarred(TStrings *newbars);

        int __fastcall GetMlistNames(TStrings *mlist, TStringList *names);
        int __fastcall GetRlistNames(TStrings *rlist, TStringList *names);

        bool __fastcall GetCypherpunkRemailersChanged(TStrings *newkeys);
        bool __fastcall ReportNewCypherpunkRemailers(TStrings *newkeys);
        bool __fastcall GetMixmasterRemailersChanged(TStrings *newkeys);
        bool __fastcall ReportNewMixmasterRemailers(TStrings *Report);

        AnsiString __fastcall GetIniValue(const AnsiString &Section, const AnsiString &Name,
           const AnsiString &DefValue);
        void __fastcall SetIniValue(const AnsiString &Section, const AnsiString &Name,
           const AnsiString &Value);
};

//---------------------------------------------------------------------------
extern PACKAGE TQSStatsWin4 *QSStatsWin4;
//---------------------------------------------------------------------------
#endif
